const Table = require('cli-table2');
const path = require('path');
const fs = require('fs');
const fe = require('fs-extra');
const url = require('url');
const {URL} = url;
// const logUpdate = require("log-update");

module.exports = function (options = {
    filename: 'mock',
    webpackConfig: null,
    server: null
}) {
    // 默认要监听的文件或路径
    options.filename = options.filename || '/mock';
    // 监听回调函数
    const watchCallback = () => {
        // 让浏览器刷新
        options.server.sockWrite(options.server.sockets, 'content-changed');
    }
    // 监听mock文件变化，以入口文件的目录作为根路径
    Object.values(options.webpackConfig.entry).forEach(arrJs => {
        arrJs = arrJs.filter(js => js.indexOf('node_modules') === -1);
        if (arrJs && arrJs.length) {
            for (let i = 0; i < arrJs.length; i++) {
                const watchTarget = path.join(path.parse(arrJs[i]).dir, options.filename);
                fe.ensureDirSync(watchTarget);
                const stat = fs.statSync(watchTarget);
                if (stat.isFile()) {
                    fs.watchFile(watchTarget, watchCallback);
                } else if (stat.isDirectory()) {
                    fs.watch(watchTarget, watchCallback);
                }
            }
        }
    });

    return function mockDevMiddleware(req, res, next) {
        if (path.parse(req.url.split('?')[0]).ext || !options.webpackConfig || !req.headers.referer) { // 不是ajax请求 || 没有webpack配置 || req.headers.referer为undefied
            next();
        } else {
            options.mockjson = path.join(options.webpackConfig.resolve.alias.pages, path.parse(new URL(req.headers.referer).pathname).dir, path.parse(options.filename).ext ? options.filename : options.filename + '/index.js');
            //  mock文件不存在
            if (!fs.existsSync(options.mockjson)) {
                next();
                return;
            }
            if (fs.statSync(options.mockjson).isFile()) {
                try {
                    const table = new Table({head: ['请求路径', '开关[enable]'], style: {border: []}});
                    const mockjson = eval(`(${fs.readFileSync(options.mockjson).toString()})`);
                    if (mockjson.enable === false) {
                        table.push([options.mockjson.replace(options.webpackConfig.resolve.alias.pages + '/', '') + '文件mock总开关', `${mockjson.enable}`]);
                        console.log(table.toString());
                        // logUpdate(table.toString());
                        next();
                        return;
                    } else {
                        table.push([options.mockjson.replace(options.webpackConfig.resolve.alias.pages + '/', '') + '文件mock总开关', `true`]);
                    }
                    let mockdata = mockjson[url.parse(req.url).pathname];
                    if (typeof mockdata === 'function') { // 如果是一个函数，则执行函数，并传入请求参数和req，res对象
                        mockdata = mockdata(req.query, req, res);
                        if (!mockdata) throw new Error(req.url.pathname + '函数没有返回值，返回内容为：' + mockdata);
                    }
                    if (mockdata === undefined) {
                        next();
                    } else if (mockdata.enable || mockdata.enable === void 0) {
                        table.push([url.parse(req.url).pathname, true]);
                        console.log(table.toString());
                        // logUpdate(table.toString());
                        // console.log(url.parse(req.url).pathname + ' => enable：', mockdata.enable);
                        delete mockdata.enable;
                        res.setHeader('ik-mock-dev-middleware', 'This is a mock data !');
                        res.json(mockdata);
                        res.end();
                    } else {
                        next();
                        table.push([url.parse(req.url).pathname, mockdata.enable]);
                        console.log(table.toString());
                        // logUpdate(table.toString());
                        // console.log(url.parse(req.url).pathname + ' => enable：', mockdata.enable);
                    }
                } catch (e) {
                    if (e.message.indexOf('Unexpected') !== -1) console.log('语法错误：', options.mockjson + '有错误，请检查您的语法');
                    console.error(e.stack);
                    next();
                }
            } else {
                next();
            }
        }
    }
}
